{ This is the input data: N;  P[1]; P[2]; ....; P[N]
 7
 2
 3
 7
 4
 5
 6
 1
                                 
                               ---------------

       .    upgrade  
  ,         .   
    ,      .   
        .      -
   -           
       .       
  ,    1 .       -
         .   
     -  .     ,
     .        -
  ,    .

    :          1  N  
   -          1,2,...,N,
             ,  -
         1    .   -
 ,     0, 1  2.   0,    1,2,....,N.
     x = 1...N    P[1...N]  
 P[P[x]]=x,   1,   1       -
  (x,P[x])      1,2,..,N.   -
      2.   ,       
  ,      x   P[P[x]]=x.  
    ,       .
       P[P[x]]=x    ?
   :    (1,P[1]).   
 (1,P[1]),       (P[1],1).   ,
      ,    P[P[1]]=1.    -
       P[1]     P[x].   -
   (P[x],P[P[x]])    .   -
     ,  ,       -
 .     a,      -
    (a,P[a]).      ,   -
  P[P[a]]=a.      (b,P[b]),  b  , 
  P[b]=a.       ,  -
     .      -    -
 , -       :
     for BegValue:= 1 to N
       a:=BegValue;
       if not _(a) then
         repeat
           NewA:=Poz[a];
           Swap(P[a],Poz[a]);
           _(P[a]):=true;
	   _(Poz[a]):=true;
           a:=NewA;
         until _(P[a]);
   Swap(i1,i2)      i1
  i2,   a=Poz[x]    a,   P[a]=x.  - -
        ,    -
   .   Adjust   ,   
  P[i]  ,      x=1...N   P[P[x]]=x
       1 .       
 ,         .   -
       .  Arrange -
    Adjust    1,2,..,N  1 .  -
      ,   .     , 
  .
}

CONST InFileName  = 'BANK.PAS';
      MaxN = 10000;

VAR P,Poz: array[1..MaxN] of integer;
    N,Turns: integer;
    NewTurn: boolean;

Procedure ReadData; {read N and P[1...N] from input file}
Var F: Text;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N);
  for N:= 1 to N do
    begin ReadLn(F,P[N]); Poz[P[N]]:=N; end;
  Close(F);
End;

Procedure Swap(Index1,Index2:integer); {Swap P[Index1] with P[Index2]}
Var Tmp: integer; {if Index1 <> Index2. Otherwise do nothing}
Begin
  if Index1 = Index2 then Exit;
  if NewTurn then
    begin Inc(Turns); WriteLn('Turn ',Turns,' :'); NewTurn:=false; end;
  WriteLn(Index1,'-',Index2);
  Tmp:=P[Index1]; P[Index1]:=P[Index2]; P[Index2]:=Tmp;
  Poz[P[Index1]]:=Index1; Poz[P[Index2]]:=Index2;
End;

Procedure Adjust; {Adjust P[1..N] in such order that P[P[a]]=a for a=1..N}
Var a,BegValue,NewA: integer;
    Swapped: array[1..MaxN] of boolean;
Begin
  FillChar(Swapped,SizeOf(Swapped),false);
  NewTurn:=true;
  for BegValue:= 1 to N do
    begin
      a:=BegValue;
      if not Swapped[a] then
        repeat
          NewA:=Poz[a];
          Swap(P[a],Poz[a]);
          Swapped[P[a]]:=true; Swapped[Poz[a]]:=true;
          a:=NewA;
        until Swapped[P[a]];
    end;
End;

Procedure Arrange; {Arrange P in normal order. Swap every 'a' with 'P[a]'}
Var a: integer;
Begin
  NewTurn:=true;
  for a:= 1 to N do
    Swap(a,P[a]);
End;

BEGIN
  ReadData;
  WriteLn;
  Turns:=0;
  Adjust;
  Arrange;
  WriteLn('Total ',Turns,' turns');
END.