{ This is then input data /an IFTHENELSE program/ :
100 IF a=b THEN 100 ELSE 101
101 IF h=s THEN 102 ELSE 103
102 IF c=d THEN 103 ELSE 104
103 IF e=f THEN 104 ELSE 105
104 IF g=h THEN 105 ELSE 106
105 IF i=j THEN 106 ELSE 113
106 IF k=l THEN 107 ELSE 112
107 IF m=n THEN 108 ELSE 111
108 IF o=p THEN 109 ELSE 110
109 RETURN(109)
110 RETURN(-110)
111 RETURN(111)
112 RETURN(-112)
113 IF x=a then 100 ELSE 114
114 RETURN(114)

                            IFTHENELSE
                           -----------------

     IFTHENELSE       -
 :
    <> IF <>=<> THEN <> ELSE <>
    <> RETURN(< >)
  <>     (  ),  <>  
  .       IFTHENELSE    
      .  IF ... THEN ... ELSE
       THEN,     
     ELSE   .   RETURN  
       .     
           20 .
          .  
            -
  .          -
  ,   ,     -
 .         ,  -
     "cycling".

  :       .   -
  IF a=b THEN .. ELSE ..      -
  a  b.    ,     -
  "THEN".   ,      "ELSE".  
         (     -
 ),     .        (  -
               -
     )      "THEN" .  -
      .      
     "ELSE" .       
    "RETURN",    ,    -
     .    ,        -
         .    
  ,     Used      , -
        ,       
     ,     .     
 ,      ,  ,    -
 .           .
       ,       
    .        
       .    -
  ,     Backtracking,     -
      ,     -
    .      - 20,
    .         
     .    
    -   .       
       -   .    -
         . 
             , -
      ,      
     ,         -
  (        ),   
     ,     -
 .         .  
 Prev[v]    v  0  .   -
 ,        .      
  ,           
  . ,           -
   .               -
 .         ,  -
     .      -
      -     ,    
    .         -
    ,     ,   -
   :       ,   -
  ,       .    -
           ,  -
     .       -
      1..5000.        -
 .
}

CONST InFileName  = 'BASIC.PAS';
      OutFileName = '';
      MaxRows     = 5000;
      MaxRezults  = 100;
      rezError    = 32766;
      rezCycling  = 32767;

TYPE TRow = record
              Typ: (aNumber,aIfThenElse);
              Number: integer;
              op1,op2: char;
              ThenRow,ElseRow: integer;
              Used: boolean;
            end;
     Table = array[#0..#128,#0..#128] of boolean;

VAR R: array[0..MaxRows] of TRow;
    FirstRow: integer;
    UsedVariables: array[#0..#128] of boolean;
    BrRezults: integer;
    Rezults: array[1..MaxRezults] of integer;
    Prev: array[#0..#128] of char;
    Unequal: ^Table;
    OutF: Text;

Procedure ReadData; {Read R[], FirstRow}
Var F: Text;
    S: string;
    RowNumber,i: integer;
  Function GetNumber: integer;
  Var i,Rez: integer;
      C: string;
  Begin
    C:='';
    while S[1] in ['0'..'9','-'] do
      begin C:=C+S[1]; Delete(S,1,1); end;
    Val(C,Rez,i);
    GetNumber:=Rez;
  End;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  FillChar(UsedVariables,SizeOf(UsedVariables),false);
  FillChar(R,SizeOf(R),0); FirstRow:=MaxInt;
  for i:= 0 to MaxRows do {Clear all rows}
    begin R[i].Typ:=aNumber; R[i].Number:=rezError; end;
  repeat
    ReadLn(F,S);
    if S = '' then Break;
    S:=S+'@'; while Pos(' ',S)<>0 do Delete(S,Pos(' ',S),1);
    RowNumber:=GetNumber;
    if FirstRow = MaxInt then FirstRow:=RowNumber;
    with R[RowNumber] do
      if S[1] = 'R' then
        begin {"RETURN(...)" command found}
          Typ:= aNumber;
          Delete(S,1,7);
          Number:= GetNumber;
        end
    else
      begin {"IF ...=... THEN ... ELSE ..." command found}
        Typ:=aIfThenElse;
        op1:=S[3]; op2:=S[5];
        Delete(S,1,9); ThenRow:= GetNumber;
        Delete(S,1,4); ElseRow:= GetNumber;
        UsedVariables[op1]:=true; UsedVariables[op2]:=true;
      end;
  until EOF(F);
  Close(F);
End;

Function Root(V:char): char;
Begin {Return the root of V in the forest Prev[]. If V has no root, return V}
  while Prev[V] <> #0 do V:=Prev[V];
  Root:=V;
End;

Procedure TraceProgram(Row:integer); {Trace the program row Row}

  Procedure WriteRezult(Number:integer); {if Number is not already}
  Var i,Counter: integer; {printed print it and all variables values}
      Value: array[#0..#128] of integer;
      V,RootV: char;
      First: boolean;
  Begin
    for i:= 1 to BrRezults do {Check if Number is not already displayed}
      if Rezults[i] = Number then Exit;
    inc(BrRezults); Rezults[BrRezults]:=Number;
    if Number= rezError then
      WriteLn(OutF,'Row ',Row,' not found!')
    else if Number= rezCycling then
      WriteLn(OutF,'cycling:')
    else WriteLn(OutF,Number);
    {Find variable values. Variables in the same tree must have equal values}
    FillChar(Value,SizeOf(Value),0);
    Counter:=0; First:=true;
    for V:= #0 to #128 do
      if UsedVariables[V] then
        begin
          RootV:=Root(V);
          Value[V]:=Value[RootV];
          if Value[V] = 0 then
	    begin Inc(Counter); Value[V]:= Counter; Value[RootV]:=Counter; end;
          if not First then Write(OutF,',');
          Write(OutF,V,'=',Value[V]);
          First:=false;
	end;
    WriteLn(OutF);
  End;

Var V1: char;
    Old1,Old2: boolean;
Begin
  with R[Row] do
    begin
      if Used then {A cycle detected in the program}
        begin WriteRezult(rezCycling); Exit; end;
      Used:=true;
      if Typ = aNumber then {"RETURN(...)" row found}
        WriteRezult(Number)
      else
        if Root(op1) = Root(op2) then
          TraceProgram(ThenRow) {op1 = o2}
        else if Unequal^[op1,op2] then
          TraceProgram(ElseRow) {op1 <> o2}
        else
          begin  {op1 ? op2}
            {Try recursively the case when op1 = op2}
            V1:=Root(op1); Prev[V1]:=Root(op2);
            TraceProgram(ThenRow);
            Prev[V1]:=#0;
            {Try recursively the case when op1 <> op2}
            Unequal^[op1,op2]:=true; Unequal^[op2,op1]:=true;
            TraceProgram(ElseRow);
            Unequal^[op1,op2]:=false; Unequal^[op2,op1]:=false;
          end;
      Used:=false;
    end;
End;

BEGIN
  WriteLn; WriteLn; WriteLn;
  ReadData;
  Assign(OutF,OutFileName); Rewrite(OutF);
  BrRezults:=0;
  FillChar(Prev,SizeOf(Prev),#0);
  New(Unequal); FillChar(Unequal^,SizeOf(Unequal^),false);
   TraceProgram(FirstRow);
  Close(OutF);
END.