{
                               
                             --------------------

      N ,        S.   
     . ,       
  ,       .  -
      a*k      k*b    -
  a*k*b .     N ,    -
 ,      .        -
   ,        .
              -
     :
   M(x,x) = 0    x = 1...N
   M(i,j) = Min(  M(i,k) + M(k+1,j) + S(i-1)*S(k)*S(j)  )   k = i...j-1
 :
   M(i,j)    ,     
             i  j  1 <= i < j <= N
   S(x-1)  S(x)       x- 
           1 <= x <= N
         ( ) 
 M(1,N).          M,  -
       ,    
  k,   M(i,j)  ,    .   -
   M(j,i)  ,  i<=j      
   .          -
 ,    k=M(j,i),      
  . i  . k    . k+1   j,   
 k ,         i  k,   -
      k+1  j       
  .
          , M(i,j)   -
 ,           ,  -
      (  "memory function").  
  M    N*N,      O(N*N*N), 
     - N*N        
  N ,     .
    ,         
   N   N-   .  :
                  (N+1)*(N+2)*...*(2N-2)
         Kat(N) = ----------------------
                      1*2*...*(N-1)
            -
  -    ,    .
}


{$M 65520,0,655360} {       }

CONST MaxMartics  = 100;
      EndLess     = 65535;
      EndLessByte = 255;

VAR MinMat: array[1..MaxMartics,1..MaxMartics] of word;
    { MinMat(i,j) (i<j)  .     .  }
    { i  j,  MinMat(j,i) (j>i)  ,      }
    {    - [ i  MinMat(j,i)]  [ MinMat(j,i)+1  j]        }
    Size: array[0..MaxMartics] of word;

Function MinMatrix(i,j:byte): word; {   }
Var Min,ValueK: word;   {      i  j}
    K: byte;
Begin
  if i=j then MinMatrix:=0 {MinMatrics[i,i]=0 }
  else {     ,     }
    if MinMat[i,j]<>EndLess then
      MinMatrix:=MinMat[i,j]
  else {  k    ,     }
    begin {    .  i  k  .  k+1  j}
      Min:=EndLess;
      for k:= i to j-1 do
        begin
          ValueK:= MinMatrix(i,k) + MinMatrix(k+1,j) +
                  Size[i-1]*Size[k]*Size[j];
          if ValueK < Min then
            begin Min:=ValueK; MinMat[j,i]:=k; end;
        end;
      MinMat[i,j]:=Min; MinMatrix:=Min;
    end;
End;

Function GetSkobiOrder(L,R:byte): string;
Begin {   !}
  if L=R then GetSkobiOrder:= chr( L + ord('A')-1 )
  else GetSkobiOrder:= '('+GetSkobiOrder(L,MinMat[R,L])+'*'
                          +GetSkobiOrder(MinMat[R,L]+1,R)+')';
End;


VAR N: byte;

BEGIN
  N:=4;
  Size[0]:=13; Size[1]:=5; Size[2]:=89; Size[3]:=3; Size[4]:=34;

  FillChar(MinMat,SizeOf(MinMat),EndLessByte);
  WriteLn('Min = ',MinMatrix(1,N),'.  Rez = ',GetSkobiOrder(1,N));
END.