{
   2:
      ,      
           
  .
   ,        .

    INPUT2.TXT   3 .     
      .     
3 :           (
 ).
     OUTPUT2.TXT     -   
   (      ).

  :                  :
INPUT2.TXT                           OUTPUT2.TXT
0 5.0                                46.64
10.00 -5
3.0 1 4.000

:
}
{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 65000,0,655360}
const epsilon=0.01; {          
                     - ,  }

type tcoord=real; {         }
     tvalue=real; {Invalid floating point operation,   }
     tangle=real; {8087/80287,        }

     tpoint=record
       x,y:tcoord;
     end;
     tpolarpoint=record
       a:tangle;
       d:tvalue;
     end;

var quad1,quad2:tpoint;
    center:tpoint;
    radius:tvalue;

    result:tvalue;

procedure inp; {.1 }
  var f:text;
  begin
    assign(f,'input2.txt'); {   }
    reset(f);
    readln(f,quad1.x,quad1.y); {   }
    readln(f,quad2.x,quad2.y); {   }
    readln(f,center.x,center.y,radius); {     }
    close(f); {    }
  end;

procedure wrout;{.5 }
  var f:text;
  begin
    assign(f,'output2.txt');
    rewrite(f);
    writeln(f,result:0:2);
    close(f);
  end;

procedure centerit; {.2 }
  begin {      }
    quad2.x:=quad2.x-quad1.x;
    quad2.y:=quad2.y-quad1.y;
    center.x:=center.x-quad1.x;
    center.y:=center.y-quad1.y;
    quad1.x:=0;
    quad1.y:=0;
  end;

procedure rotate; {.3   }
{            1h30'(pi/4)}
  var q2p,cp:tpolarpoint;
  procedure topolar(p:tpoint;var result:tpolarpoint);
  {.3.1    }
    begin {     ,    var }
      if p.x=0 then
        result.a:=pi/2
      else
        result.a:=arctan(p.y/p.x);{   (-pi/2;pi/2)(12h-6h)}
      if (p.x<0) or               {    pi/2(12h)   }
        ((p.x=0) and (p.y<0)) then
        result.a:=result.a+pi;  {         [6h-12h)   pi}
      result.d:=sqrt(sqr(p.x)+sqr(p.y));
    end;

  procedure frompolar(pp:tpolarpoint;var result:tpoint);
  {.3.3    }
    var thesin,thecos:tvalue;
    begin
      result.x:=cos(pp.a)*pp.d;{       }
      result.y:=sin(pp.a)*pp.d;
    end;

  begin
    topolar(quad2,q2p);  {.3.1    }
    topolar(center,cp);
    cp.a:=cp.a+((pi/4)-q2p.a);  {.3.2   }
    q2p.a:=pi/4;
    frompolar(q2p,quad2); {.3.3    }
    frompolar(cp,center)
  end;

function pointinside(x,y:tcoord):boolean;
  begin
    pointinside:=(sqr(x-center.x)+sqr(y-center.y)<=sqr(radius));
    {      ...,      .}
  end;

function pointoutside(x,y:tcoord):boolean;
  begin
    pointoutside:=(sqr(x-center.x)+sqr(y-center.y)>=sqr(radius));
  end;

function quadinside(x1,y1,x2,y2:tcoord):boolean;
{        
     }
  begin
    quadinside:=pointinside(x1,y1) and pointinside(x2,y2) and
                pointinside(x1,y2) and pointinside(x2,y1);
  end;

function quadoutside(x1,y1,x2,y2:tcoord):boolean;
{      }
  begin
    if not pointoutside(x1,y1) or
       not pointoutside(x1,y2) or
       not pointoutside(x2,y1) or
       not pointoutside(x2,y2) then begin
      quadoutside:=false;
      exit;
    end; {       ,      }
    if (center.y<=y1-radius) or
       (center.y>=y2+radius) or
       (center.x<=x1-radius) or
       (center.x>=x2+radius) then begin
      quadoutside:=true;
      exit;
    end; {   ,     .....}
    if (center.y<y1) and (center.x<x1) or
       (center.y<y1) and (center.x>x2) or
       (center.y>y2) and (center.x<x1) or
       (center.y>y2) and (center.x>x2) then begin
      quadoutside:=true;
      exit;
    end;{,       ...,
               :) }
    quadoutside:=false;
  end;

function microinside(x1,y1,x2,y2:tcoord):boolean;
{        }
{            }
  begin
    microinside:=sqr((x1+x2)/2-center.x)+sqr((y1+y2)/2-center.y)<sqr(radius);
  end;

function rec(x1,y1,x2,y2:tcoord):tvalue; {.4     }
  var cx,cy:tcoord;
  begin
    if abs(x1-x2)<epsilon then begin {      }
      if microinside(x1,y1,x2,y2) then rec:=sqr(x2-x1) { }
                                  else rec:=0; {       }
      exit;{      }
    end;
    if quadinside(x1,y1,x2,y2) then begin {    }
      rec:=sqr(x2-x1);    {       }
      exit;
    end;
    if quadoutside(x1,y1,x2,y2) then begin
      rec:=0;          {   ,      0}
      exit;
    end;
    cx:=(x1+x2)/2; {           4  }
    cy:=(y1+y2)/2; {        4- }
    rec:=rec(x1,y1,cx,cy)+rec(cx,y1,x2,cy)+rec(x1,cy,cx,y2)+rec(cx,cy,x2,y2);
  end;

begin
  inp;                                          {.1 }
  centerit;                                     {.2 }
  rotate;                                       {.3 }
  result:=rec(quad1.x,quad1.y,quad2.x,quad2.y); {.4  }
  wrout;                                        {.5   }
end.

  input2.txt
0.0 0.0
1.0 1.0
1.0 1.0 0.5

  output2.txt
0.20

  .
1. :
       (  :)

2. :
           ,    
   .        .

3. :
       ....,       
       .      
            , 
      3 ,      ,  
    .     1,1   
  :45, :2. (1,-1)  ::-45, :2

3.1.    :
  ..            
  ,        . 
    2   .....

3.2.  :
       ,  ,    ,
            45,    
       "", ..      
   .

3.3.        .
         3.1 .    .

4.  .
             
   .
         .

  1.      :   .

  2.    :     .

  3.       , ..    :  
          4-     .

  4.            4 .
        . :)
             
  ,    .
                 
            .    -
       4-      , 
         -,   
    -

5. 
           .
